Loading...
Searching...
No Matches
pcl::GridMinimum< PointT > Class Template Reference
Module filters

GridMinimum assembles a local 2D grid over a given PointCloud, and downsamples the data. More...

`#include <pcl/filters/grid_minimum.h>`

Inheritance diagram for pcl::GridMinimum< PointT >:

## Public Member Functions

| GridMinimum (const float resolution)
| Empty constructor.
| ~GridMinimum () override=default
| Destructor.
void | setResolution (const float resolution)
| Set the grid resolution.
float | getResolution ()
| Get the grid resolution.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Types

using | PointCloud = typename FilterIndices<PointT>::PointCloud

## Protected Member Functions

void | applyFilter (PointCloud &output) override
| Downsample a Point Cloud using a 2D grid approach.
void | applyFilter (Indices &indices) override
| Filtered results are indexed by an indices array.
void | applyFilterIndices (Indices &indices)
| Filtered results are indexed by an indices array.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

float | resolution_
| The resolution.
float | inverse_resolution_
| Internal resolution stored as 1/resolution_ for efficiency reasons.
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Additional Inherited Members

Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | Ptr = shared_ptr<FilterIndices<PointT> >
using | ConstPtr = shared_ptr<const FilterIndices<PointT> >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr<Filter<PointT> >
using | ConstPtr = shared_ptr<const Filter<PointT> >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Detailed Description

template<typename PointT>
class pcl::GridMinimum< PointT >

GridMinimum assembles a local 2D grid over a given PointCloud, and downsamples the data.

The GridMinimum class creates a 2D grid over the input point cloud data. Then, in each cell (i.e., 2D grid element), all the points present will be downsampled with the minimum z value. This grid minimum can be useful in a number of topographic processing tasks such as crudely estimating ground returns, especially under foliage.

Author
  Bradley J Chambers

Definition at line 61 of file grid_minimum.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT>

using pcl::GridMinimum< PointT >::PointCloud = typename FilterIndices<PointT>::PointCloud

protected

Definition at line 69 of file grid_minimum.h.

## Constructor & Destructor Documentation

## GridMinimum()

template<typename PointT>

pcl::GridMinimum< PointT >::GridMinimum | ( | const float | resolution | ) |

inline

Empty constructor.

Definition at line 73 of file grid_minimum.h.

References pcl::Filter< PointT >::filter_name_, and setResolution().

## ~GridMinimum()

template<typename PointT>

pcl::GridMinimum< PointT >::~GridMinimum | ( |  | ) |

override default

Destructor.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT>

void pcl::GridMinimum< PointT >::applyFilter | ( | Indices & | indices | ) |

inline override protected virtual

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Implements pcl::FilterIndices< PointT >.

Definition at line 114 of file grid_minimum.h.

References applyFilterIndices().

## applyFilter() [2/2]

template<typename PointT>

void pcl::GridMinimum< PointT >::applyFilter | ( | PointCloud & | output | ) |

override protected virtual

Downsample a Point Cloud using a 2D grid approach.

Parameters

  [out] | output | the resultant point cloud message

Reimplemented from pcl::FilterIndices< PointT >.

Definition at line 61 of file grid_minimum.hpp.

References applyFilterIndices(), pcl::copyPointCloud(), pcl::Filter< PointT >::getClassName(), and pcl::PCLBase< PointT >::input_.

## applyFilterIndices()

template<typename PointT>

void pcl::GridMinimum< PointT >::applyFilterIndices | ( | Indices & | indices | ) |

protected

Filtered results are indexed by an indices array.

Parameters

  [out] | indices | The resultant indices.

Definition at line 81 of file grid_minimum.hpp.

References pcl::Filter< PointT >::getClassName(), pcl::getMinMax3D(), pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::input_, inverse_resolution_, and pcl::isXYZFinite().

Referenced by applyFilter(), and applyFilter().

## getResolution()

template<typename PointT>

float pcl::GridMinimum< PointT >::getResolution | ( |  | ) |

inline

Get the grid resolution.

Definition at line 95 of file grid_minimum.h.

References resolution_.

## setResolution()

template<typename PointT>

void pcl::GridMinimum< PointT >::setResolution | ( | const float | resolution | ) |

inline

Set the grid resolution.

Parameters

  [in] | resolution | the grid resolution

Definition at line 86 of file grid_minimum.h.

References inverse_resolution_, and resolution_.

Referenced by GridMinimum().

## Member Data Documentation

## inverse_resolution_

template<typename PointT>

float pcl::GridMinimum< PointT >::inverse_resolution_

protected

Internal resolution stored as 1/resolution_ for efficiency reasons.

Definition at line 102 of file grid_minimum.h.

Referenced by applyFilterIndices(), and setResolution().

## resolution_

template<typename PointT>

float pcl::GridMinimum< PointT >::resolution_

protected

The resolution.

Definition at line 99 of file grid_minimum.h.

Referenced by getResolution(), and setResolution().

The documentation for this class was generated from the following files:

- pcl/filters/grid_minimum.h
- pcl/filters/impl/grid_minimum.hpp